// Test matching exchaustive
// $Id: t9.g,v 1.1 2002/02/08 07:40:15 malekith Exp $
extern_c void print_string(string);
extern_c void print_int(int);

union expr {
	int Const;
        int Var;
        *[expr, expr] Add;
        *[expr, expr] Sub;
        *[expr, expr] Mul;
        *[expr, expr] Div;
        *[expr, int] Pow;
}

int compute(expr e) {
        switch (e) {
        case Const[x]:  return x;
        case Var[x]:    return x;
        case Add[e1, e2]: return compute(e1) + compute(e2);
        case Sub[e1, e2]: return compute(e1) - compute(e2);
        case Mul[e1, e2]: return compute(e1) * compute(e2);
        case Div[e1, e2]: return compute(e1) / compute(e2);     
        case Pow[e1, n] : 
             int ex;
             ex = compute(e1);
             if (n == 1) return ex;
             else return ex * compute(Pow[e1, n-1]);
        }
}

expr diff(expr e) {
        switch e {
        case Const[_]: return Const[0];
        case Var[_]:   return Const[1];
        case Add[e1, e2]: return Add[diff(e1), diff(e2)];
        case Sub[e1, e2]: return Sub[diff(e1), diff(e2)];
        case Mul[e1, e2]: 
               return Add[Mul[diff(e1), e2], Mul[e1, diff(e2)]];
        case Div[e1, e2]:
               expr up = Sub[Mul[diff(e1), e2], Mul[e1, diff(e2)]];
               expr down = Mul[e2, e2]; 
               return Div[up, down];
        case Pow[ex, n]:
               return Mul[diff(Pow[ex,n-1]), diff(ex)];
        }
}

int main() export_as "main"
{
        expr e = Sub[Add[Mul[Var[3], Var[3]], Mul[Const[2], Var[3]]], Const[1]]; 
        print_int(compute(e));
        print_string(", ");
        expr eprim = diff(e);
        print_int(compute(eprim));
        print_string(", ");
        expr ebis = diff(eprim);
        print_int(compute(ebis));
        print_string(".\n");
      	return 0;
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 14, 8, 2.
 */
